unit Main;
{ (C) Copyright 1998 by Victor A.Voilevitch 
}

interface

uses
  SysUtils, Windows, Graphics, Classes, Forms,
  Controls, ExtCtrls;

const
  MouseMovesToAwake = 7;

type
  ImArray   = Array [1..4] of ^TImage;
  PImArray  = ^ImArray;
  TMainForm = class(TForm)
    EsherImage1: TImage;
    EsherImage2: TImage;
    EsherImage3: TImage;
    EsherImage4: TImage;
    EIm1: TImage;
    EIm2: TImage;
    EIm3: TImage;
    EIm4: TImage;
    procedure ProcOnCreate(Sender: TObject);
    procedure ProcOnClick(Sender: TObject);
    procedure ProcOnKey(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure ProcOnMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure ProcOnPaint(Sender: TObject);
  private
    MovesCount : Integer;
    MyBoxSz    : Integer;
    ni, nj     : Integer; // images per screen side
    Images     : ImArray;
    Ims        : ImArray;
    PCurrIms   : PImArray;
    procedure DrawArray(PArr : PImArray);
  end;


var
  MainForm       : TMainForm;

implementation

{$R *.DFM}

{========================================================}
procedure TMainForm.ProcOnCreate(Sender: TObject);
begin
  Height := Screen.Height;
  Width  := Screen.Width;
  PixelsPerInch := Screen.PixelsPerInch;
  Screen.Cursor := CrNone;
  MovesCount := 0;
  MyBoxSz := 40;
  ni := Screen.Width  div MyBoxSz;
  nj := Screen.Height div MyBoxSz;
  Color := clGray;
  Images[1] := @EsherImage1;
  Images[2] := @EsherImage2;
  Images[3] := @EsherImage3;
  Images[4] := @EsherImage4;
  Ims[1] := @EIm1;
  Ims[2] := @EIm2;
  Ims[3] := @EIm3;
  Ims[4] := @EIm4;
  PCurrIms  := @Images;
end;

{========================================================}
procedure TMainForm.ProcOnClick(Sender: TObject);
begin
  // Close;
  DrawArray(PCurrIms);
end;

{========================================================}
procedure TMainForm.ProcOnKey(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if ((Shift = [ssAlt]) and (Key = VK_F3)) then Close;
  if Key = VK_F1
    then if PCurrIms = @Images
           then PCurrIms := @Ims
           else PCurrIms := @Images;
  DrawArray(PCurrIms);
end;

{========================================================}
procedure TMainForm.ProcOnMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
begin
  if MovesCount < MouseMovesToAwake
    then Inc(MovesCount)
    else // Close;
         DrawArray(PCurrIms);
end;

{========================================================}
procedure TMainForm.ProcOnPaint(Sender: TObject);
begin
  DrawArray(PCurrIms);
end;

{========================================================}
procedure TMainForm.DrawArray(PArr : PImArray);
var
  i,  j  : Integer;
begin
  if PArr <> Nil then
   for i:=0 to ni-1 do
    for j:=0 to nj-1 do
     Canvas.Draw(i*MyBoxSz, j*MyBoxSz,
                 PArr^[1+Random(4)]^.Picture.Bitmap);
end;

end.
